/*
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package com.inteligr8.wildfly.maven;

import org.apache.maven.execution.MavenSession;
import org.apache.maven.model.building.ModelBuilder;
import org.apache.maven.plugin.logging.Log;
import org.apache.maven.project.MavenProject;
import org.apache.maven.project.ProjectModelResolver;
import org.eclipse.aether.impl.ArtifactResolver;

/**
 * @author brian@inteligr8.com
 */
public interface DependencyAwareComponent {
    
    Log getLog();
    
    MavenSession getMavenSession();
    
    MavenProject getMavenProject();
    
    ProjectModelResolver getProjectModelResolver();
    
    ArtifactResolver getArtifactResolver();
    
    ModelBuilder getModelBuilder();

}
