package com.inteligr8.wildfly.maven.util;

import java.io.File;

import javax.inject.Singleton;

@Singleton
public class DirectoryAccessor {
    
    public File validateAndInitializeDirectory(File directory) {
        if (directory.exists() && !directory.isDirectory())
            throw new IllegalArgumentException("A directory was expected: " + directory);
        
        directory.mkdirs();
        return directory;
    }
    
    public File validateAndInitializeDirectory(File directory, String extraPath) {
        directory = this.validateAndInitializeDirectory(directory);
        
        File extraDirectory = new File(directory, extraPath);
        if (extraDirectory.exists() && !extraDirectory.isDirectory())
            throw new IllegalStateException("The formulated directory is a file: " + extraDirectory);
        
        extraDirectory.mkdirs();
        return extraDirectory;
    }
    
    public File validateAndInitializeDirectory(File directory, String moduleId, String moduleVersion) {
        directory = this.validateAndInitializeDirectory(directory);
        
        for (String dir : moduleId.split("\\.")) {
            directory = new File(directory, dir);
            if (directory.exists() && !directory.isDirectory())
                throw new IllegalStateException("The formulated directory contains a file: " + directory);
        }
        
        File versionDirectory = new File(directory, moduleVersion);
        if (versionDirectory.exists() && !versionDirectory.isDirectory())
            throw new IllegalStateException("The formulated directory contains a file: " + directory);
        
        versionDirectory.mkdirs();
        return versionDirectory;
    }

}