/*
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
 * more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
package com.inteligr8.wildfly.maven.xml;

import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Element;

/**
 * {@link https://github.com/wildfly/wildfly-core/tree/main/server/src/main/resources/schema}
 * @author brian@inteligr8.com
 */
public class DeploymentXmlBuilder extends AbstractXmlBuilder {

    public DeploymentXmlBuilder(String schemaVersion) throws ParserConfigurationException {
        super("urn:jboss:deployment-structure:" + schemaVersion, true);

        Element deploymentElement = this.xmldoc.createElementNS(this.ns, "deployment");
        deploymentElement.appendChild(this.dependenciesElement);
        
        Element rootElement = this.xmldoc.createElementNS(this.ns, "jboss-deployment-structure");
        rootElement.appendChild(deploymentElement);
        
        this.xmldoc.appendChild(rootElement);
    }
    
    @Override
    public String getXmlFilename() {
        return "jboss-deployment-structure.xml";
    }

}
